/*
 * common.h - part of Ivona tools (Ivona synthesizer by Ivo Software)
 * Copyright (C) Bohdan R. Rau 2008 <ethanak@polip.com>
 * 
 * Ivona tools is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * Ivona tools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ivona tools.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */
#ifndef IVONAS_COMMON_H
#define IVONAS_COMMON_H 1

/* audio functions */

int ao_callback(char *data,int len);
void ao_list_drivers(void);
void ao_add_option(char *option,int is_cli);
int audio_is_live(void);

/* speaker functions */

int init_addr(void);
void say(char *str,int (*callback)(char *,int));

/* configuration */

extern int ivonaMode;

extern char ivonaServerHost[];
extern int ivonaServerPort;
extern char ivonaServerLanguage[];
extern int ivonaServerRate;

extern char ivonaCliBinary[];
extern char ivonaCliVoice[];
extern char ivonaCliLanguage[];
extern char *ivonaCliArgs[];
extern int ivonaCliRate;

extern int ivonaWebServicePort;
extern int ivonaWebServiceAutoStop;
extern int ivonaWebServiceDaemon;
extern int ivonaWebServiceUrlDecode;
extern int ivonaSSIPServerPort;
extern char ivonaSSIPPunctChars[];
extern int ivonaSSIPPunctuation;
extern int ivonaSSIPCapLetRec;

extern char ivonaAudioDriver[];
extern char ivonaAudioFileName[];

extern int ivonaRate;
extern char *ivonaLanguage;
extern char ivonaSSIPVoiceName[];

extern int ivona_LineConf(int argc,char *argv[],int ws);

#endif
