/*
 * ivona say.c - part of Ivona tools (Ivona synthesizer by Ivo Software)
 * Copyright (C) Bohdan R. Rau 2008 <ethanak@polip.com>
 * 
 * Ivona tools is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * Ivona tools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ivona tools.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libdumbtts.h>
#include <ctype.h>
#include <langinfo.h>
#include "common.h"


int main(int argc,char *argv[])
{
	char buf[8192];
	char *obuf;
	struct dumbtts_conf *conf;
	int len,n,oargc,live;
	
	oargc=ivona_LineConf(argc,argv,0);
	
	obuf=NULL;
	len=0;
	conf=dumbtts_TTSInit(ivonaLanguage);
	if (oargc < argc) {
		char *c=buf;
		for (;oargc<argc;oargc++) {
			strcpy(c,argv[oargc]);
			c+=strlen(c);
			if (oargc<argc-1) *c++=' ';
		}
		n=dumbtts_GetString(conf,buf,obuf,len,0,NULL,",.!?;:");
		if (n>0) {
			len=n;
			obuf=malloc(len);
			if (!obuf) {
				perror("malloc");
				exit(1);
			}
			n=dumbtts_GetString(conf,buf,obuf,len,0,NULL,",.!?;:");
		}
		if (!n) {
			say(obuf,ao_callback);
		}
		exit(0);
	}
	live = audio_is_live();
	
	while (fgets(buf,8192,stdin)) {
		n=dumbtts_GetString(conf,buf,obuf,len,0,NULL,",.!?;:");
		if (n>0) {
			len=n+1024;
			if (!obuf) obuf=malloc(len);
			else obuf=realloc(obuf,len);
			if (!obuf) {
				perror("malloc");
				exit(1);
			}
			n=dumbtts_GetString(conf,buf,obuf,len,0,NULL,",.!?;:");
		}
		if (n) continue;
		say(obuf,ao_callback);
		if (!live) break;
	}
	return 0;
}
